#include <sys/types.h>
#include <pwd.h>
#include <grp.h>
#include <stdio.h>
#include <unistd.h>

void pw_info(struct passwd *pw);

int main()
{
    uid_t uid;
    gid_t gid;
    struct passwd *pw;
    struct group *grp;

    uid = getuid();
    gid = getgid();

    printf("User is %s\n", getlogin());

    printf("User IDs: uid=%d, gid=%d\n", uid, gid);

    grp = getgrgid(gid);
    printf("User's group: %s\n",grp->gr_name);

    pw = getpwuid(uid);
    printf("UID passwd entry:\n");
    pw_info(pw);

    pw = getpwnam("root");
    printf("root passwd entry:\n");
    pw_info(pw);
    return 0;
}

void pw_info(struct passwd *pw)
{
    printf("name=%s, uid=%d, gid=%d, home=%s, shell=%s\n",
        pw->pw_name, pw->pw_uid, pw->pw_gid, pw->pw_dir, pw->pw_shell);
}
